package cz.muni.fi.pv168.project.model.db;

import cz.muni.fi.pv168.project.db.interfaces.DataAccessObject;
import cz.muni.fi.pv168.project.ui.dialog.error.ErrorDialog;

public class UpdatableDataModel<E> extends AbstractDataModel<E> {

    protected final DataAccessObject<E> dataAccessObject;

    public UpdatableDataModel(DataAccessObject<E> dao) {
        this.dataAccessObject = dao;
        updateAll();
    }

    @Override
    public void delete(E entity) {
        dataAccessObject.delete(entity);
    }

    @Override
    public void add(E entity) {
        dataAccessObject.add(entity);
    }

    @Override
    public void update(E entity) {
        dataAccessObject.update(entity);
    }

    public void updateAll() {
        clear();
        try {
            addAll(dataAccessObject.getAll());
        } catch (Exception e) {
            e.printStackTrace();
            ErrorDialog.show("Error when querying all elements.", e);
        }
    }
}
